
#ifndef __atree_h__
#define __atree_h__

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __atree_c__
typedef struct _atree_t *patree_t;
#endif

/* 
 *  This indexing library is intended to provide a fast data retrieval  
 *  from simple [small] dictionaries. It is memory extensive.
 */

size_t	 atree_sizeof();
patree_t atree_new();
patree_t atree_destroy(patree_t p);
void *   atree_retrieve(patree_t p, char *key);
void *   atree_store(patree_t p, char *key, void *data);

/* for debugging purpose: */
void     atree_dump(patree_t p, void (*f_dumpdata)(void *));

#ifdef __cplusplus
}
#endif

#endif
