#ifndef _srv_h_
#define _srv_h_

#ifndef _srv_c_ 
typedef void *psrv_t;
#endif

enum {
	srvUNKNOWN = 0,
	srvCREATING,
	srvCONFIGURING,
	srvBINDING,
	srvCONNECTING,
	srvLISTENING
};

#ifdef __cplusplus
extern "C" {
#endif

size_t srv_sizeof();

psrv_t srv_destroy(psrv_t s);
psrv_t srv_new(int port, int maxclients);

int srv_status(psrv_t s);
int srv_port(psrv_t s);
int srv_socket(psrv_t s);
int srv_maxclients(psrv_t s);
int srv_clients_connected(psrv_t s);

int srv_client_connect(psrv_t s);
int srv_client_disconnect(psrv_t s, int cid);

int srv_recv_to(int cid, char *data, size_t size, int sec, int usec);
int srv_recv(int cid, char *data, size_t size);
int srv_send(int cid, char *data, size_t size);

#ifdef __cplusplus
}
#endif

#endif
